JUCE: TableHeaderComponent Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
TableHeaderComponent Class Reference
juce_gui_basics » widgets

A component that displays a strip of column headings for a table, and allows these to be resized, dragged around, etc. More...

`#include <juce_TableHeaderComponent.h>`

Inheritance diagram for TableHeaderComponent:

## Classes
class | Listener
| Receives events from a TableHeaderComponent when columns are resized, moved, etc. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes. More...

## Public Types
enum | ColumnPropertyFlags { visible = 1 , resizable = 2 , draggable = 4 , appearsOnColumnMenu = 8 , sortable = 16 , sortedForwards = 32 , sortedBackwards = 64 , defaultFlags = (visible | resizable | draggable | appearsOnColumnMenu | sortable) , notResizable = (visible | draggable | appearsOnColumnMenu | sortable) , notResizableOrSortable = (visible | draggable | appearsOnColumnMenu) , notSortable = (visible | resizable | draggable | appearsOnColumnMenu) }
| A combination of these flags are passed into the addColumn() method to specify the properties of a column. More...
enum | ColourIds { textColourId = 0x1003800 , backgroundColourId = 0x1003810 , outlineColourId = 0x1003820 , highlightColourId = 0x1003830 }
| A set of colour IDs to use to change the colour of various aspects of the TableHeaderComponent. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions
| TableHeaderComponent ()
| Creates an empty table header.
| ~TableHeaderComponent () override
| Destructor.
void | addColumn (const String &columnName, int columnId, int width, int minimumWidth=30, int maximumWidth=-1, int propertyFlags=defaultFlags, int insertIndex=-1)
| Adds a column to the table.
void | removeColumn (int columnIdToRemove)
| Removes a column with the given ID.
void | removeAllColumns ()
| Deletes all columns from the table.
int | getNumColumns (bool onlyCountVisibleColumns) const
| Returns the number of columns in the table.
String | getColumnName (int columnId) const
| Returns the name for a column.
void | setColumnName (int columnId, const String &newName)
| Changes the name of a column.
void | moveColumn (int columnId, int newVisibleIndex)
| Moves a column to a different index in the table.
int | getColumnWidth (int columnId) const
| Returns the width of one of the columns.
void | setColumnWidth (int columnId, int newWidth)
| Changes the width of a column.
void | setColumnVisible (int columnId, bool shouldBeVisible)
| Shows or hides a column.
bool | isColumnVisible (int columnId) const
| Returns true if this column is currently visible.
void | setSortColumnId (int columnId, bool sortForwards)
| Changes the column which is the sort column.
int | getSortColumnId () const
| Returns the column ID by which the table is currently sorted, or 0 if it is unsorted.
bool | isSortedForwards () const
| Returns true if the table is currently sorted forwards, or false if it's backwards.
void | reSortTable ()
| Triggers a re-sort of the table according to the current sort-column.
int | getTotalWidth () const
| Returns the total width of all the visible columns in the table.
int | getIndexOfColumnId (int columnId, bool onlyCountVisibleColumns) const
| Returns the index of a given column.
int | getColumnIdOfIndex (int index, bool onlyCountVisibleColumns) const
| Returns the ID of the column at a given index.
Rectangle< int > | getColumnPosition (int index) const
| Returns the rectangle containing of one of the columns.
int | getColumnIdAtX (int xToFind) const
| Finds the column ID at a given x-position in the component.
void | setStretchToFitActive (bool shouldStretchToFit)
| If set to true, this indicates that the columns should be expanded or shrunk to fill the entire width of the component.
bool | isStretchToFitActive () const
| Returns true if stretch-to-fit has been enabled.
void | resizeAllColumnsToFit (int targetTotalWidth)
| If stretch-to-fit is enabled, this will resize all the columns to make them fit into the specified width, keeping their relative proportions the same.
void | setPopupMenuActive (bool hasMenu)
| Enables or disables the pop-up menu.
bool | isPopupMenuActive () const
| Returns true if the pop-up menu is enabled.
String | toString () const
| Returns a string that encapsulates the table's current layout.
void | restoreFromString (const String &storedVersion)
| Restores the state of the table, based on a string previously created with toString().
void | addListener (Listener *newListener)
| Adds a listener to be informed about things that happen to the header.
void | removeListener (Listener *listenerToRemove)
| Removes a previously-registered listener.
virtual void | columnClicked (int columnId, const ModifierKeys &mods)
| This can be overridden to handle a mouse-click on one of the column headers.
virtual void | addMenuItems (PopupMenu &menu, int columnIdClicked)
| This can be overridden to add custom items to the pop-up menu.
virtual void | reactToMenuItem (int menuReturnId, int columnIdClicked)
| Override this to handle any custom items that you have added to the pop-up menu with an addMenuItems() override.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
void | mouseMove (const MouseEvent &) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
MouseCursor | getMouseCursor () override
| Returns the mouse cursor shape to use when the mouse is over this component.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
virtual void | showColumnChooserMenu (int columnIdClicked)
| Can be overridden for more control over the pop-up menu behaviour.
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChanged() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor.

## Additional Inherited Members
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Detailed Description

A component that displays a strip of column headings for a table, and allows these to be resized, dragged around, etc.

This is just the component that goes at the top of a table. You can use it directly for custom components, or to create a simple table, use the TableListBox class.

To use one of these, create it and use addColumn() to add all the columns that you need. Each column must be given a unique ID number that's used to refer to it.

See also
  TableListBox, TableHeaderComponent::Listener

## Member Enumeration Documentation

## ◆ ColumnPropertyFlags

enum TableHeaderComponent::ColumnPropertyFlags

A combination of these flags are passed into the addColumn() method to specify the properties of a column.

Enumerator
visible | If this is set, the column will be shown; if not, it will be hidden until the user enables it with the pop-up menu.
resizable | If this is set, the column can be resized by dragging it.
draggable | If this is set, the column can be dragged around to change its order in the table.
appearsOnColumnMenu | If this is set, the column will be shown on the pop-up menu allowing it to be hidden/shown.
sortable | If this is set, then clicking on the column header will set it to be the sort column, and clicking again will reverse the order.
sortedForwards | If this is set, the column is currently the one by which the table is sorted (forwards).
sortedBackwards | If this is set, the column is currently the one by which the table is sorted (backwards).
defaultFlags | This set of default flags is used as the default parameter value in addColumn().
notResizable | A quick way of combining flags for a column that's not resizable.
notResizableOrSortable | A quick way of combining flags for a column that's not resizable or sortable.
notSortable | A quick way of combining flags for a column that's not sortable.

## ◆ ColourIds

enum TableHeaderComponent::ColourIds

A set of colour IDs to use to change the colour of various aspects of the TableHeaderComponent.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
textColourId | The colour for the text in the header.
backgroundColourId | The colour of the table header background. It's up to the LookAndFeel how this is used.
outlineColourId | The colour of the table header's outline.
highlightColourId | The colour of the table header background when the mouse is over or down above the the table header. It's up to the LookAndFeel to use a variant of this colour to distinguish between the down and hover state.

## Constructor & Destructor Documentation

## ◆ TableHeaderComponent()

TableHeaderComponent::TableHeaderComponent | ( |  | ) |

Creates an empty table header.

## ◆ ~TableHeaderComponent()

TableHeaderComponent::~TableHeaderComponent | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ addColumn()

void TableHeaderComponent::addColumn | ( | const String & | columnName,
|  | int | columnId,
|  | int | width,
|  | int | minimumWidth = 30,
|  | int | maximumWidth = -1,
|  | int | propertyFlags = defaultFlags,
|  | int | insertIndex = -1 )

Adds a column to the table.

This will add a column, and asynchronously call the tableColumnsChanged() method of any registered listeners.

Parameters

  columnName | the name of the new column. It's ok to have two or more columns with the same name
  columnId | an ID for this column. The ID can be any number apart from 0, but every column must have a unique ID. This is used to identify the column later on, after the user may have changed the order that they appear in
  width | the initial width of the column, in pixels
  maximumWidth | a maximum width that the column can take when the user is resizing it. This only applies if the 'resizable' flag is specified for this column
  minimumWidth | a minimum width that the column can take when the user is resizing it. This only applies if the 'resizable' flag is specified for this column
  propertyFlags | a combination of some of the values from the ColumnPropertyFlags enum, to define the properties of this column
  insertIndex | the index at which the column should be added. A value of 0 puts it at the start (left-hand side) and -1 puts it at the end (right-hand size) of the table. Note that the index the index within all columns, not just the index amongst those that are currently visible

## ◆ removeColumn()

void TableHeaderComponent::removeColumn | ( | int | columnIdToRemove | ) |

Removes a column with the given ID.

If there is such a column, this will asynchronously call the tableColumnsChanged() method of any registered listeners.

## ◆ removeAllColumns()

void TableHeaderComponent::removeAllColumns | ( |  | ) |

Deletes all columns from the table.

If there are any columns to remove, this will asynchronously call the tableColumnsChanged() method of any registered listeners.

## ◆ getNumColumns()

int TableHeaderComponent::getNumColumns | ( | bool | onlyCountVisibleColumns | ) | const

Returns the number of columns in the table.

If onlyCountVisibleColumns is true, this will return the number of visible columns; otherwise it'll return the total number of columns, including hidden ones.

See also
  isColumnVisible

## ◆ getColumnName()

String TableHeaderComponent::getColumnName | ( | int | columnId | ) | const

Returns the name for a column.

See also
  setColumnName

## ◆ setColumnName()

void TableHeaderComponent::setColumnName | ( | int | columnId,
|  | const String & | newName )

Changes the name of a column.

## ◆ moveColumn()

void TableHeaderComponent::moveColumn | ( | int | columnId,
|  | int | newVisibleIndex )

Moves a column to a different index in the table.

Parameters

  columnId | the column to move
  newVisibleIndex | the target index for it, from 0 to the number of columns currently visible.

## ◆ getColumnWidth()

int TableHeaderComponent::getColumnWidth | ( | int | columnId | ) | const

Returns the width of one of the columns.

## ◆ setColumnWidth()

void TableHeaderComponent::setColumnWidth | ( | int | columnId,
|  | int | newWidth )

Changes the width of a column.

This will cause an asynchronous callback to the tableColumnsResized() method of any registered listeners.

## ◆ setColumnVisible()

void TableHeaderComponent::setColumnVisible | ( | int | columnId,
|  | bool | shouldBeVisible )

Shows or hides a column.

This can cause an asynchronous callback to the tableColumnsChanged() method of any registered listeners.

See also
  isColumnVisible

## ◆ isColumnVisible()

bool TableHeaderComponent::isColumnVisible | ( | int | columnId | ) | const

Returns true if this column is currently visible.

See also
  setColumnVisible

## ◆ setSortColumnId()

void TableHeaderComponent::setSortColumnId | ( | int | columnId,
|  | bool | sortForwards )

Changes the column which is the sort column.

This can cause an asynchronous callback to the tableSortOrderChanged() method of any registered listeners.

If this method doesn't actually change the column ID, then no re-sort will take place (you can call reSortTable() to force a re-sort to happen if you've modified the table's contents).

See also
  getSortColumnId, isSortedForwards, reSortTable

## ◆ getSortColumnId()

int TableHeaderComponent::getSortColumnId | ( |  | ) | const

Returns the column ID by which the table is currently sorted, or 0 if it is unsorted.

See also
  setSortColumnId, isSortedForwards

## ◆ isSortedForwards()

bool TableHeaderComponent::isSortedForwards | ( |  | ) | const

Returns true if the table is currently sorted forwards, or false if it's backwards.

See also
  setSortColumnId

## ◆ reSortTable()

void TableHeaderComponent::reSortTable | ( |  | ) |

Triggers a re-sort of the table according to the current sort-column.

If you modify the table's contents, you can call this to signal that the table needs to be re-sorted.

(This doesn't do any sorting synchronously - it just asynchronously sends a call to the tableSortOrderChanged() method of any listeners).

## ◆ getTotalWidth()

int TableHeaderComponent::getTotalWidth | ( |  | ) | const

Returns the total width of all the visible columns in the table.

## ◆ getIndexOfColumnId()

int TableHeaderComponent::getIndexOfColumnId | ( | int | columnId,
|  | bool | onlyCountVisibleColumns ) const

Returns the index of a given column.

If there's no such column ID, this will return -1.

If onlyCountVisibleColumns is true, this will return the index amongst the visible columns; otherwise it'll return the index amongst all the columns, including any hidden ones.

## ◆ getColumnIdOfIndex()

int TableHeaderComponent::getColumnIdOfIndex | ( | int | index,
|  | bool | onlyCountVisibleColumns ) const

Returns the ID of the column at a given index.

If onlyCountVisibleColumns is true, this will count the index amongst the visible columns; otherwise it'll count it amongst all the columns, including any hidden ones.

If the index is out-of-range, it'll return 0.

## ◆ getColumnPosition()

Rectangle< int > TableHeaderComponent::getColumnPosition | ( | int | index | ) | const

Returns the rectangle containing of one of the columns.

The index is an index from 0 to the number of columns that are currently visible (hidden ones are not counted). It returns a rectangle showing the position of the column relative to this component's top-left. If the index is out-of-range, an empty rectangle is returned.

## ◆ getColumnIdAtX()

int TableHeaderComponent::getColumnIdAtX | ( | int | xToFind | ) | const

Finds the column ID at a given x-position in the component.

If there is a column at this point this returns its ID, or if not, it will return 0.

## ◆ setStretchToFitActive()

void TableHeaderComponent::setStretchToFitActive | ( | bool | shouldStretchToFit | ) |

If set to true, this indicates that the columns should be expanded or shrunk to fill the entire width of the component.

By default this is disabled. Turning it on also means that when resizing a column, those on the right will be squashed to fit.

## ◆ isStretchToFitActive()

bool TableHeaderComponent::isStretchToFitActive | ( |  | ) | const

Returns true if stretch-to-fit has been enabled.

See also
  setStretchToFitActive

## ◆ resizeAllColumnsToFit()

void TableHeaderComponent::resizeAllColumnsToFit | ( | int | targetTotalWidth | ) |

If stretch-to-fit is enabled, this will resize all the columns to make them fit into the specified width, keeping their relative proportions the same.

If the minimum widths of the columns are too wide to fit into this space, it may actually end up wider.

## ◆ setPopupMenuActive()

void TableHeaderComponent::setPopupMenuActive | ( | bool | hasMenu | ) |

Enables or disables the pop-up menu.

The default menu allows the user to show or hide columns. You can add custom items to this menu by overloading the addMenuItems() and reactToMenuItem() methods.

By default the menu is enabled.

See also
  isPopupMenuActive, addMenuItems, reactToMenuItem

## ◆ isPopupMenuActive()

bool TableHeaderComponent::isPopupMenuActive | ( |  | ) | const

Returns true if the pop-up menu is enabled.

See also
  setPopupMenuActive

## ◆ toString()

String TableHeaderComponent::toString | ( |  | ) | const

Returns a string that encapsulates the table's current layout.

This can be restored later using restoreFromString(). It saves the order of the columns, the currently-sorted column, and the widths.

See also
  restoreFromString

## ◆ restoreFromString()

void TableHeaderComponent::restoreFromString | ( | const String & | storedVersion | ) |

Restores the state of the table, based on a string previously created with toString().

See also
  toString

## ◆ addListener()

void TableHeaderComponent::addListener | ( | Listener * | newListener | ) |

Adds a listener to be informed about things that happen to the header.

## ◆ removeListener()

void TableHeaderComponent::removeListener | ( | Listener * | listenerToRemove | ) |

Removes a previously-registered listener.

## ◆ columnClicked()

virtual void TableHeaderComponent::columnClicked | ( | int | columnId,
|  | const ModifierKeys & | mods )
| virtual

This can be overridden to handle a mouse-click on one of the column headers.

The default implementation will use this click to call getSortColumnId() and change the sort order.

## ◆ addMenuItems()

virtual void TableHeaderComponent::addMenuItems | ( | PopupMenu & | menu,
|  | int | columnIdClicked )
| virtual

This can be overridden to add custom items to the pop-up menu.

If you override this, you should call the superclass's method to add its column show/hide items, if you want them on the menu as well.

Then to handle the result, override reactToMenuItem().

See also
  reactToMenuItem

## ◆ reactToMenuItem()

virtual void TableHeaderComponent::reactToMenuItem | ( | int | menuReturnId,
|  | int | columnIdClicked )
| virtual

Override this to handle any custom items that you have added to the pop-up menu with an addMenuItems() override.

If the menuReturnId isn't one of your own custom menu items, you'll need to call TableHeaderComponent::reactToMenuItem() to allow the base class to handle the items that it had added.

See also
  addMenuItems

## ◆ paint()

void TableHeaderComponent::paint | ( | Graphics & | g | ) |
| overridevirtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from Component.

## ◆ resized()

void TableHeaderComponent::resized | ( |  | ) |
| overridevirtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from Component.

## ◆ mouseMove()

void TableHeaderComponent::mouseMove | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse moves inside a component.

If the mouse button isn't pressed and the mouse moves over a component, this will be called to let the component react to this.

A component will always get a mouseEnter callback before a mouseMove.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseExit, mouseDrag, contains

Reimplemented from Component.

## ◆ mouseEnter()

void TableHeaderComponent::mouseEnter | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse first enters a component.

If the mouse button isn't pressed and the mouse moves into a component, this will be called to let the component react to this.

When the mouse button is pressed and held down while being moved in or out of a component, no mouseEnter or mouseExit callbacks are made - only mouseDrag messages are sent to the component that the mouse was originally clicked on, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseExit, mouseDrag, mouseMove, contains

Reimplemented from Component.

## ◆ mouseExit()

void TableHeaderComponent::mouseExit | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse moves out of a component.

This will be called when the mouse moves off the edge of this component.

If the mouse button was pressed, and it was then dragged off the edge of the component and released, then this callback will happen when the button is released, after the mouseUp callback.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseDrag, mouseMove, contains

Reimplemented from Component.

## ◆ mouseDown()

void TableHeaderComponent::mouseDown | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from Component.

## ◆ mouseDrag()

void TableHeaderComponent::mouseDrag | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from Component.

## ◆ mouseUp()

void TableHeaderComponent::mouseUp | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from Component.

## ◆ getMouseCursor()

MouseCursor TableHeaderComponent::getMouseCursor | ( |  | ) |
| overridevirtual

Returns the mouse cursor shape to use when the mouse is over this component.

The default implementation will return the cursor that was set by setCursor() but can be overridden for more specialised purposes, e.g. returning different cursors depending on the mouse position.

See also
  MouseCursor

Reimplemented from Component.

## ◆ createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > TableHeaderComponent::createAccessibilityHandler | ( |  | ) |
| overridevirtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from Component.

## ◆ showColumnChooserMenu()

virtual void TableHeaderComponent::showColumnChooserMenu | ( | int | columnIdClicked | ) |
| virtual

Can be overridden for more control over the pop-up menu behaviour.

The documentation for this class was generated from the following file:

- juce_TableHeaderComponent.h